/*
 * Copyright (c) 2017 SpaceToad and the BuildCraft team
 * This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0. If a copy of the MPL was not
 * distributed with this file, You can obtain one at https://mozilla.org/MPL/2.0/
 */

package buildcraft.lib.misc;

import net.minecraft.util.math.BlockPos;
import net.minecraft.util.math.ChunkPos;
import net.minecraft.world.World;
import net.minecraft.world.chunk.Chunk;

public class ChunkUtil {
    private static final ThreadLocal<Chunk> lastChunk = new ThreadLocal<>();

    public static Chunk getChunk(World world, BlockPos pos, boolean force) {
        return getChunk(world, pos.func_177958_n() >> 4, pos.func_177952_p() >> 4, force);
    }

    public static Chunk getChunk(World world, ChunkPos pos, boolean force) {
        return getChunk(world, pos.field_77276_a, pos.field_77275_b, force);
    }

    public static Chunk getChunk(World world, int x, int z, boolean force) {
        Chunk chunk = lastChunk.get();

        if (chunk != null) {
            if (chunk.func_177410_o()) {
                if (chunk.func_177412_p() == world && chunk.field_76635_g == x && chunk.field_76647_h == z) {
                    return chunk;
                }
            } else {
                lastChunk.set(null);
            }
        }

        if (force) {
            chunk = world.func_72863_F().func_186025_d(x, z);
        } else {
            chunk = world.func_72863_F().func_186026_b(x, z);
        }

        if (chunk != null) {
            lastChunk.set(chunk);
        }
        return chunk;
    }
}
