package buildcraft.lib.misc.data;

import net.minecraft.client.Minecraft;
import net.minecraft.profiler.Profiler;

import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

/** An extension for minecraft's {@link Profiler} class that returns {@link AutoCloseable} profiler sections. */
public class ProfilerBC {

    @SideOnly(Side.CLIENT)
    public static ProfilerBC getClient() {
        return new ProfilerBC(Minecraft.func_71410_x().field_71424_I);
    }

    private final Profiler profiler;

    public ProfilerBC(Profiler profiler) {
        this.profiler = profiler;
    }

    public IProfilerSection start(String name) {
        profiler.func_76320_a(name);
        return profiler::func_76319_b;
    }

    public IProfilerSection start(String... names) {
        for (String s : names) {
            profiler.func_76320_a(s);
        }
        return () -> {
            for (int i = 0; i < names.length; i++) {
                profiler.func_76319_b();
            }
        };
    }

    public interface IProfilerSection extends AutoCloseable {
        /** Ends the current profiler section. Will only throw if this was called incorrectly. */
        @Override
        void close();
    }
}
